/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package it.tidalwave.semantic.node.impl;

import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.SortedSet;
import java.util.TreeSet;
import javax.annotation.Nonnull;

/**
 *
 * @author fritz
 */
public class NameSpaceSegmenter
  {
    private final SortedSet<String> nameSpaces = new TreeSet<String>();
    private final SortedSet<String> pendingSet = new TreeSet<String>();
    
    public void add (@Nonnull final String nameSpace)
      {
        if (nameSpaces.isEmpty() && pendingSet.isEmpty()) // first one
          {
            pendingSet.add(nameSpace);
          }
        else if (nameSpaces.contains(nameSpace) || pendingSet.contains(nameSpace))
          {
            return; // no news
          }
        else // try to match with something
          {
            final List<String> list = new ArrayList<String>();
            list.addAll(nameSpaces);
            list.addAll(pendingSet);

            for (final String pending : list)
              {
                final String root = common(pending, nameSpace);
                System.err.println("TRYING ROOT " + root);
                
                try
                  {
                    final URI uri = new URI(root);

                    if ((uri.getPath() != null) && !uri.getPath().equals(""))
                      {
                        System.err.println("VALID: " + root + " $ " + uri.getPath());
                        // they share a valid URI

                        if (pendingSet.add(pending))
                          {
                            pendingSet.remove(pending);
                            return;
                          }

                        nameSpaces.add(root);
                      }
                  }
                catch (URISyntaxException ex)
                  {
                  }

                System.err.println("NOT VALID " + root);
              }
                
            pendingSet.add(nameSpace);
          }
      }

    public SortedSet<String> getNameSpaces()
      {
          System.err.println("UNRESOLVED " + pendingSet);
        return Collections.unmodifiableSortedSet(nameSpaces);
      }

    protected static String common (@Nonnull final String s1, @Nonnull final String s2)
      {
        assert !s1.equals(s2);

        int l = -1; // yes, -1 since it will be used as l + 1
        
        for (int i = 0; i < Math.min(s1.length(), s2.length()); i++)
          {
            final char c1 = s1.charAt(i);

            if (c1 != s2.charAt(i))
              {
                break;
//                return s1.substring(0, l + 1);
              }

            if ((c1 == '/') || (c1 == '#'))
              {
                l = i;
              }
          }

        return s1.substring(0, l + 1);
      }
  }
