/*******************************************************************************
 *
 * blueMarine - open source photo workflow
 * =======================================
 *
 * Copyright (C) 2003-2010 by Fabrizio Giudici
 * Project home page: http://bluemarine.tidalwave.it
 *
 *******************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 *******************************************************************************
 *
 * $Id: RelationNodeDelegateFactoryImpl.java,v 213fe927a495 2010/01/01 00:36:29 fabrizio $
 *
 ******************************************************************************/
package it.tidalwave.semantic.node.impl;

import javax.annotation.Nonnull;
import org.openide.nodes.Node;
import it.tidalwave.semantic.other.Relation;
import it.tidalwave.openide.nodemanager.NodeDelegateFactorySupport;

/*******************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: RelationNodeDelegateFactoryImpl.java,v 213fe927a495 2010/01/01 00:36:29 fabrizio $
 *
 ******************************************************************************/
public class RelationNodeDelegateFactoryImpl extends NodeDelegateFactorySupport<Relation>
  {
    public RelationNodeDelegateFactoryImpl (@Nonnull final Relation relation)
      {
        super(relation);
      }

    @Nonnull
    protected Node createNodeDelegate()
      {
        return new RelationNode(getOwner());
      }
  }
